//	啶̕`(GDI)
//	Visual C++ 2013 32/64bit

#include <windows.h>
#include <tchar.h>
#include <math.h>
#if _MSC_VER>1500
#include <shellscalingapi.h>
#endif
#ifndef _DPI_AWARENESS_CONTEXTS_
DECLARE_HANDLE(DPI_AWARENESS_CONTEXT);
#endif

typedef HRESULT(_stdcall* EnableNonClientDpiScalingFunc)(HWND);
typedef HRESULT(_stdcall* SetThreadDpiAwarenessContextFunc)(DPI_AWARENESS_CONTEXT);

HMODULE hModUser32 = 0;
EnableNonClientDpiScalingFunc NcDpifunc = 0;
SetThreadDpiAwarenessContextFunc ThreadAwareFunc = 0;

#ifndef _DPI_AWARENESS_CONTEXTS_

typedef enum _DPI_AWARENESS {
	DPI_AWARENESS_INVALID = -1,
	DPI_AWARENESS_UNAWARE = 0,
	DPI_AWARENESS_SYSTEM_AWARE = 1,
	DPI_AWARENESS_PER_MONITOR_AWARE = 2
} DPI_AWARENESS;

#if _MSC_VER<=1500
typedef enum MONITOR_DPI_TYPE {
	MDT_EFFECTIVE_DPI = 0,
	MDT_ANGULAR_DPI = 1,
	MDT_RAW_DPI = 2,
	MDT_DEFAULT = MDT_EFFECTIVE_DPI
} MONITOR_DPI_TYPE;
#endif

#define WM_DPICHANGED                   0x02E0

#define DPI_AWARENESS_CONTEXT_UNAWARE              ((DPI_AWARENESS_CONTEXT)-1)
#define DPI_AWARENESS_CONTEXT_SYSTEM_AWARE         ((DPI_AWARENESS_CONTEXT)-2)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE    ((DPI_AWARENESS_CONTEXT)-3)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2 ((DPI_AWARENESS_CONTEXT)-4)
#define DPI_AWARENESS_CONTEXT_UNAWARE_GDISCALED ((DPI_AWARENESS_CONTEXT)-5)
#endif


typedef HRESULT(_stdcall *GetDpiForMonitorFunc)(HMONITOR, MONITOR_DPI_TYPE, UINT *, UINT *);
typedef BOOL(_stdcall *SetProcessDPIAwareFunc)(VOID);
int win10ver2(void);
int WIN10VER;

//	EBhEvV[W[
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

TCHAR szClassName[] = TEXT("BigFont");

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,TCHAR* lpszCmdLine, int nCmdShow){
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS myProg;
	WIN10VER = win10ver2();
	hModUser32 = LoadLibrary(L"User32.dll");
	if (hModUser32){
		if (WIN10VER == 1607)	//	AnniversaryUpdate
			NcDpifunc = (EnableNonClientDpiScalingFunc)GetProcAddress(hModUser32, "EnableNonClientDpiScaling");
		else
			NcDpifunc = 0;
		ThreadAwareFunc = (SetThreadDpiAwarenessContextFunc)GetProcAddress(hModUser32, "SetThreadDpiAwarenessContext");
		if (ThreadAwareFunc){
			if (WIN10VER<1703)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE);
			if (1703 <= WIN10VER && WIN10VER<1809)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2);
			if (1809 <= WIN10VER)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_UNAWARE_GDISCALED);
		}
		else{	//	Windows Vistaȍ~
			SetProcessDPIAwareFunc ProcessAwareFunc = (SetProcessDPIAwareFunc)GetProcAddress(hModUser32, "SetProcessDPIAware");
			if (ProcessAwareFunc)
				(*ProcessAwareFunc)();
		}
	}

	if (!hPreInst) {
		myProg.style =CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc =WndProc;
		myProg.cbClsExtra =0;
		myProg.cbWndExtra =0;
		myProg.hInstance =hInstance;
		myProg.hIcon =NULL;
		myProg.hCursor =LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground =(HBRUSH)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName =NULL;
		myProg.lpszClassName =szClassName;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	hWnd = CreateWindow(szClassName,
		szClassName,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		200,
		150,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)) {
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

//	EBhEvV[W[

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;
	static int nowDPIx = 96;
	static int nowDPIy = 96;
	static UINT nowScale = 100;

	switch (msg) {
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_NCCREATE: {	//	Windows 10 Version 1607̂݌Ăяo
			if (NcDpifunc)
				(*NcDpifunc)(hWnd);
			return DefWindowProc(hWnd, msg, wParam, lParam);
		}
		case WM_DPICHANGED:{
			nowDPIx = LOWORD(wParam);
			nowDPIy = HIWORD(wParam);
			nowScale = MulDiv(nowDPIx, 100, 96);
			RECT& rect = *((RECT*)lParam);
			int cx = rect.right - rect.left;
			int cy = rect.bottom - rect.top;
			SetWindowPos(hWnd,NULL,rect.left,rect.top,cx,cy,SWP_NOZORDER | SWP_NOACTIVATE);
			break;
		}
		case WM_PAINT:{
			hdc = BeginPaint(hWnd, &ps);
			RECT rect;
			GetClientRect(hWnd, &rect);
			double scr = double(rect.right) / double(rect.bottom);
			int h = rect.bottom;
			TCHAR* str=_TEXT("MS");
			TCHAR* fontName = _TEXT("lr ");
			HFONT hFont = CreateFont(
				h, 0, 0, 0, 0, FALSE, FALSE, FALSE,
				SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
				CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
				VARIABLE_PITCH,fontName
				);
			SIZE size;
			HFONT hOldFont = (HFONT)SelectObject(hdc, hFont);
			GetTextExtentPoint32(hdc, str, _tcslen(str), &size);
			double font = double(size.cx) / double(size.cy);
			if (scr < font){	//	͂ݏoĂ
				h =h*rect.right/size.cx ;
				SelectObject(hdc, hOldFont);
				DeleteObject(hFont);
				hFont = CreateFont(
					h, 0, 0, 0, 0, FALSE, FALSE, FALSE,
					SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
					CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
					VARIABLE_PITCH, fontName
					);
				SelectObject(hdc, hFont);
				GetTextExtentPoint32(hdc, str, _tcslen(str), &size);
			}
			TextOut(hdc, (rect.right-size.cx)/2, (rect.bottom-size.cy)/2, str, (int)_tcslen(str));
			TCHAR buf[32];
			_stprintf_s(buf, sizeof(buf) / sizeof(buf[0]), _TEXT("bigfont[%i*%isNZ]"), size.cx,size.cy);
			SetWindowText(hWnd, buf);
			SelectObject(hdc, hOldFont);
			DeleteObject(hFont);
			EndPaint(hWnd, &ps);
			break;
		}
		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}

//	DLL̊֐ւ̃|C^^`
typedef void (WINAPI *RtlGetVersion_FUNC)(OSVERSIONINFOEXW*);

int win10ver2(void){
	int ver = 0;
	HMODULE hMod;
	OSVERSIONINFOEXW osw;
	hMod = LoadLibrary(TEXT("ntdll.dll"));
	RtlGetVersion_FUNC func;
	if (hMod){
		func = (RtlGetVersion_FUNC)GetProcAddress(hMod, "RtlGetVersion");
		if (func == 0){
			FreeLibrary(hMod);
			return FALSE;
		}
		ZeroMemory(&osw, sizeof(osw));
		osw.dwOSVersionInfoSize = sizeof(osw);
		func(&osw);
		FreeLibrary(hMod);
		if (osw.dwMajorVersion == 10){
			switch (osw.dwBuildNumber){
			case 10240: ver = 1507; break;
			case 10586: ver = 1511; break;
			case 14393: ver = 1607; break;
			case 15063: ver = 1703; break;
			case 16299: ver = 1709; break;
			case 17134: ver = 1803; break;
			case 17763: ver = 1809; break;
			default: ver = 1809; break;
			}
			return ver;
		}
	}
	return -1;
}